/*
This NanoJ Example Code is based on our experience with typical user requirements in a wide range
of industrial applications and is provided without guarantee regarding correctness and completeness.
It serves as general guidance and should not be construed as a commitment of Nanotec to guarantee its
applicability to the customer application without additional tests under the specific conditions
and  if and when necessary  modifications by the customer. 

The responsibility for the applicability and use of the NanoJ Example Code in a particular
customer application lies solely within the authority of the customer.
It is the customer's responsibility to evaluate, investigate and decide,
whether the Example Code is valid and suitable for the respective customer application, or not.
Defects resulting from the improper handling of devices and modules are excluded from the warranty.
Under no circumstances will Nanotec be liable for any direct, indirect, incidental or consequential damages
arising in connection with the Example Code provided. In addition, the regulations regarding the
liability from our Terms and Conditions of Sale and Delivery shall apply.
*/

//in diesem Beispiel wird der Positionsmodus gewhlt und gestartet, nach dem Triggersignal wird eine analog vorgegebene Position angefahren (Flagpositionsmodus)


//1. Schritt: mappen von hufig verwenden SDOs
map U16 ControlWord as output 0x6040:00
map U32 ProfileVelocity as output 0x6081:00
map S32 TargetPosition as output 0x607A:00
map U32 Inputs as input 0x60FD:00
map S32 ActualPosition as input 0x6064:00
map S32 AnalogInput as input 0x3320:01

#include "wrapper.h"



//2. Schritt: Hauptfunktion aufrufen und gewnschte Einstellungen treffen
void user()
{
	od_write(0x6060,0x00, 1);							 // setzt den Operationsmodus auf Positionsmodus
	Out.ProfileVelocity = 200;						// setzt die Zielgeschwindigkeit auf 200 U/min
	Out.TargetPosition = 1000000000;					// setzt eine Zielposition, nur als Limit
		
//3. Schritt: State maschine hochfahren	
	Out.ControlWord = 0x6;				// schaltet in den Zustand "enable voltage"
	do 	{
			yield();						// warten auf den nchsten Zyklus (1ms)
		}
		while ( (od_read(0x6041, 0x00) & 0xEF) != 0x21);   // wartet bis der Zustand ist "enable voltage" 

	// berprft das Statusword (0x6041) auf die Bitmaske: xxxx xxxx x01x 0001
	
	Out.ControlWord = 0x7;	// schaltet in den Zustand "switched on"
	do 	{
			yield();						// warten auf den nchsten Zyklus (1ms)
		}
		while ( (od_read(0x6041, 0x00) & 0xEF) != 0x23);   // wartet bis der Zustand ist "switched on" 
		// berprft das Statusword (0x6041) auf die Bitmaske xxxx xxxx x01x 0011	
		
	Out.ControlWord = 0x4F;	// schaltet in den Zustand "enable operation" , Zielposition relative
	do 	{
			yield();						// warten auf den nchsten Zyklus (1ms)
		}
		while ( (od_read(0x6041, 0x00) & 0xEF) != 0x27);   // wartet bis der Zustand ist "operation enabled"	
		// berprft das Statusword (0x6041) auf die Bitmaske: xxxx xxxx x01x 0111	
	
	Out.ControlWord = 0x5F;								// startet die Fahrt	
	yield();
		
		
	while(true)         // Endlosschleife
	{	
		//3. Schritt: neue Zielposition senden sobald EIngang 1 (Trigger) high
		if((In.Inputs & 0x10000) == 0x10000)				// wenn Eingang 1 (Trigger) high...
		{
			Out.TargetPosition = In.ActualPosition + (In.AnalogInput * 10);	  //setzt die neue Zielposition abhngig von der Istposition und Analogeingang 
			Out.ProfileVelocity = 50;						// neue Zielgeschwidnigkeit=50 U/min
			yield();
			Out.ControlWord = 0x2F;							// setzt das Startbit 4 zurck ,neue Zielposition muss sofort bernommen werrden (Bit 5)
			yield();
			Out.ControlWord = 0x3F;							// startet die  absolute Positionierung 	
			yield();
			while((In.Inputs & 0x10000) == 0x10000)			// warte whrend Eingang 1 noch high
			{
				yield();
			}	
		}
		yield();
	}	
}	